function yhat = forecast(y,B,G)

% (yhat(t) is the predicted value for y(t))
% The exponentail smoothing recursion
%
%     yhat(t+1) = yhat(t) + B(y(t)-yhat(t)) + G(u(t+1)-u(t)), var(y(t)-yhat(t))=Sigma
%

%Definition of the explanatory variables. They depend on the different kinds of days in the week. 
N=length(y);
ninputs=size(G,2);

if (ninputs==0)
    ur=[0,0,0,0,0];
end

if (ninputs==1)
    ur=[1,1,1,1,1]; %All the days are equals
end
if (ninputs==3)
    ur=[1,0,0,0,0;0,1,1,1,0;0,0,0,0,1]; %There are three sets of days: Monday, Tuesday-Wednesday-Thursday, Friday
end
if (ninputs==5)
    ur=[1,0,0,0,0;0,1,0,0,0;0,0,1,0,0;0,0,0,1,0;0,0,0,0,1]; %The five days of the week are different
end
u=[];
for i=1:N/5
   u=[u,ur];
end

    
%The exponentail smoothing recursion
 yhat(:,1)=G(:,1);
 for i=1:length(y(1,:))-1
     yhat(:,i+1) = yhat(:,i) + B*(y(:,i)-yhat(:,i))+G*(u(:,i+1)-u(:,i)); %var(y(t)-yhat(t))=Sigma
 end
