function  [init_xs,init_Ps,Sub,Suxe,Sbb,Sbx,Sxx,Sxy,Suxo,loglik,xfilt,xsmooth]=kalman_smoother2s(y,u,A,B,C,D,Q,R,init_x,init_P);

%This function computes the standard Kalman smother filter
%for the model in the state space 

% x_{t+1} = A*x_{t} + B*u_{t} + w_{t}   var{w_(t)} = Q
% y_{t}   = C*x_{t} + D*u_{t} + v_{t}   var{v_(t)} = R

%in order to calculate:
%xsmooth(:,t)=E[X(:,t)|y(:,1:T),u(:,1:T)] t>=1
%Psmooth(:,:,t)=Var[X(:,t)|y(:,1:T),u(:,1:T)] t>=1
%PPsmooth(:,:,t)=Cov[X(:,t),X(:,t-1)|y(:,1:T),u(:,1:T)] t>=2

%using as data the kalman filter information


[os T]=size(y);
ss=size(A,1);%state space dimension

%Kalman filtering outputs
xsmooth=zeros(ss,T);
Psmooth=zeros(ss,ss,T);
PPsmooth=zeros(ss,ss,T);

%fordward pass
[xfilt,Pfilt,PPfilt,loglik,x_one_step,P_one_step,P_ant]=kalman_filter2s(y,u,A,B,C,D,Q,R,init_x,init_P);
%xfilt=E[X(:,t)|y(:,1:t),u(:,1:t)] Pfilt=Var[X(:,t)|y(t),u(:,1:t)]  para t=1:T

%backward pass
xsmooth(:,T)=xfilt(:,T);
Psmooth(:,:,T)= P_ant;
PPsmooth(:,:,T) = PPfilt;

xpred = A*xfilt(:,T-1) + B*u(:,T-1); 

J= P_ant*A'/Pfilt;


for t=T:-1:3
    
    xsmooth(:,t-1) = xfilt(:,t-1) + J*(xsmooth(:,t) - xpred); %xsmooth=E[X(:,t-1)|y(:,(1:T))]
    Psmooth(:,:,t-1) = P_ant + J*(Psmooth(:,:,t) - Pfilt)*J';  %Psmooth=Var[X(:,t-1)|y(:,(1:T))]
    
    xpred = A*xfilt(:,t-2) + B*u(:,t-2); %xpred=E[X(:,t-1)|y(:,1:t-2)]
    
    PPsmooth(:,:,t-1) = P_ant*J'+J*(PPsmooth(:,:,t) - A*P_ant)*J'; %the lag-one covariance smoother
    %PPsmooth(:,:,t-1)=Cov[X(:,t-1),X(:,t-2)|y(:,1:T),u(:,1:T)] t>=3 
    
end

xsmooth(:,1) = xfilt(:,1) + J*(xsmooth(:,2) - xpred); 
Psmooth(:,:,1) = P_ant + J*(Psmooth(:,:,2) - Pfilt)*J';  
   
init_xs=xsmooth(:,1);
init_Ps=Psmooth(:,:,1); 
    
%Here we create the matrices Sub,Suxe,Sbb,Sbx,Sxx,Sxy,Suxo used in the EM
%algorithm in the maximation step.
Sub=u(:,1)*xsmooth(:,1)'; %Sum((x_t-1|N)*(u_t-1)') for t=2:N
Suxe=u(:,1)*xsmooth(:,2)'; %Sum((x_t|N)*(u_t-1)') for t=2:N
Sbb=Psmooth(:,:,1)+xsmooth(:,1)*xsmooth(:,1)'; %Sum((P_t-1|N)+((x_t-1)|N)*((x_t-1)|N)') for t=2:N
Sbx=PPsmooth(:,:,2)'+xsmooth(:,1)*xsmooth(:,2)'; %Sum((PP_t,t-1|N)+((x_t)|N)*((x_t-1)|N)') for t=2:N
Sxx=Psmooth(:,:,2)+xsmooth(:,2)*xsmooth(:,2)'; %Sum((P_t|N)+((x_t)|N)*((x_t)|N)') for t=2:N

Sxy=xsmooth(:,2)*y(:,2)'; %Sum((y_t|N)*(x_t|N)') for t=2:N
Suxo=u(:,2)*xsmooth(:,2)'; %Sum((x_t|N)*(u_t)') for t=2:N
Suuo=u(:,2)*u(:,2)'; %Sum((u_t)*(u_t)') for t=2:N
for t=3:T
    Sub=Sub+u(:,t-1)*xsmooth(:,t-1)';
    Suxe=Suxe+u(:,t-1)*xsmooth(:,t)';
    Sbb=Sbb+Psmooth(:,:,t-1)+xsmooth(:,t-1)*xsmooth(:,t-1)';
    Sbx=Sbx+PPsmooth(:,:,t)'+xsmooth(:,t-1)*xsmooth(:,t)';
    Sxx=Sxx+Psmooth(:,:,t)+xsmooth(:,t)*xsmooth(:,t)';
    Sxy=Sxy+xsmooth(:,t)*y(:,t)';
    Suxo=Suxo+u(:,t)*xsmooth(:,t)';
    Suuo=Suuo+u(:,t)*u(:,t)';
end
